package lib.exporter;

import kernel.net.Net;
import kernel.net.Package.NetworkID;

using tink.CoreApi;

class Import {
	public static function get(ressourceLocator:String):Promise<Response> {
		var request = Request.fromString(ressourceLocator);

		return RessourceNames.get(request.id).next((response) -> {
			return performRequest(response, request);
		});
	}

	private static function performRequest(netID:NetworkID, request:Request):Promise<Response> {
		return Net.sendAndAwait(netID, "res", request).map((response) -> {
			switch (response) {
				case Success(data):
					return Success(cast(data.data, Response));
				case Failure(error):
					return Failure(error);
			}
		});
	}
}
